import os
from csst_dfs_commons.models import Result
from ..common.service import grpc_channel
from ..common.utils import *

class Level2TypeApi(object):
    def __init__(self):
        self.stub = None

    @grpc_channel
    def find(self, **kwargs):
        return find_req("Level2TypeServicer.Find", kwargs)

    @grpc_channel
    def get(self, **kwargs):
        return get_req("Level2TypeServicer.Get", kwargs)  

    @grpc_channel
    def update_import_status(self, **kwargs):
        return update_req("Level2TypeServicer.UpdateImportStatus", kwargs)

    @grpc_channel
    def write(self, **kwargs):
        try:
            data_type = get_parameter(kwargs, "data_type", "")
            if not data_type:
                return Result.error(message="the data_type is blank")
            file_path = get_parameter(kwargs, "demo_file_path", "")
            filename = get_parameter(kwargs, "demo_filename", "")            
            if not file_path:
                return Result.error(message="demo_file_path is blank")
            if not os.path.exists(file_path):
                return Result.error(message="the file [%s] not existed" % (file_path, ))
            if not filename:
                filename = os.path.basename(file_path)
                conditions = {}
                conditions.update(kwargs)
                conditions["demo_filename"] = filename
            with open(file_path, 'rb') as f:
                byte_stream = io.BytesIO(f.read())
                return write_stream_req("Level2TypeServicer.Write", byte_stream, kwargs)
        except Exception as e:
            return Result.error(message="%s" % (e,))
